
import java.util.*;
import edu.neu.ccs.demeter.dj.*;
// import edu.neu.ccs.demeter.*;

privileged aspect TripExecutions {


  //Location class executions
  void around(String n, Location l): execution(Location.new(String)) &&
      args(n, l) && this(l){
    l.name = n;
  }

  //Main class executions
  void around(Main m): execution(Main.new()) && this(m){
    // super(); - called automatically in Java
  }

  void around(String args[]):
    execution(static public void Main.main(String[])) && args(args) {

    // Build Trip-object
    Vector v1 = new Vector();
    Location l1 = new Location("Zurich");
    v1.add(l1);
    Location l2 = new Location("Chur");
    v1.add(l2);
    Location l3 = new Location("St. Moritz");
    v1.add(l3);
    Location l4 = new Location("Pontresina");
    v1.add(l4);
    Trip a = new Trip(v1,9,17);
    System.out.println("DJ start ");
    ClassGraph cg = Main.buildClassGraph();
    System.out.println();
    TraversalGraph allLocations = new TraversalGraph(
      "from Trip to Location" ,cg);
    System.out.println("---- TG begin ");
    System.out.println(allLocations);
    System.out.println("---- TG done ");
    System.out.println();
    System.out.println("Output");

    a.printItinerary(allLocations);

    System.out.println(" DONE");
  }

  ClassGraph around(): execution(public static ClassGraph Main.buildClassGraph()) {
    ClassGraph cg=new  ClassGraph(true,true);
    // true: include all fields
    // false: do NOT include all non-void no-argument methods

    System.out.println("The DJ version is: " + cg.getVersion());
    System.out.println("The class graph is" + "=============================");
    System.out.println(cg);
    System.out.println("end class graph " + "=============================");
    return cg;
  }

  // Trip class executions
  void around(Vector it, int d, int a, Trip t):
      execution(Trip.new(Vector, int, int)) && args(it, d, a)&& this(t) {
    t.itinerary = it;
    t.departure = d;
    t.arrival = a;
  }

  void around(TraversalGraph allLocations, Trip t):
      execution(void printItinerary(TraversalGraph)) &&
      args(allLocations) && this(t) {
    allLocations.traverse(t, new Visitor() {
      void before (Trip host) {System.out.println("departure " +
	host.departure);}
      void before (Location host) { System.out.println(host.name);}
      void after (Trip host) {System.out.println("arrival " +
	host.arrival);}
   });
  }
}